<?php
/*
Plugin Name: WP-Dokuwiki
Plugin URI: http://floatingsun.net/blog/code/wp-dokuwiki/
Description: Enables the use of Dokuwiki markup in your posts/pages
Version: 0.3
Author: Diwaker Gupta
Author URI: http://floatingsun.net/blog
Update Server: http://redalt.com/
Min WP Version: 2.0
Max WP Version: 2.0.1
*/

define('DOKU_INC', realpath(dirname(__FILE__)).'/');

require_once(DOKU_INC.'inc/init.php');
require_once(DOKU_INC.'inc/common.php');
require_once(DOKU_INC.'inc/html.php');
require_once DOKU_INC . 'inc/parserutils.php';

global $OpenTag;
global $CloseTag;

$OpenTag = "<wiki>";
$CloseTag = "</wiki>";

require_once('inc/parserutils.php');

function dg_parse_entry($content) {

    extract($GLOBALS);

    if ( strstr($content, $OpenTag) === FALSE) {
        return $content;
    }
    else{
        $OTagSize = strlen($OpenTag);
        $CTagSize = strlen($CloseTag);
        $index = 0;
        while($index <= strlen($content)) {
            $start = strpos($content, $OpenTag, $index);
            $end = strpos($content, $CloseTag, $start + $OTagSize);
            if($start === FALSE or $end === FALSE)
                break;
            if($start > $index) {
                $nonwiki = substr($content, $index, $start - $index);
                echo trim($nonwiki);
            }
            $wikicode = substr($content, ($start + $OTagSize), ($end - $start - $CTagSize));
            $textlines = split("\n",$wikicode);
            $text = "";
            for ($l=0; $l<count($textlines); $l++){
                /* Remove '\r' */
                $line = rtrim($textlines[$l]);
                $text = $text . $line."\n";
            }
            echo "<!-- begin Dokuwiki generated code-->";
            echo '<div class="dokuwiki">';
            echo p_render('xhtml', p_get_instructions($text), $info);
            echo '</div>';
            echo "<!-- end Dokuwiki generated code-->";
            $index = $end + $CTagSize;
        }
        echo substr($content, $index);
        $content="";
        return $content;
    }
}

function dg_add_css(){
    echo '<link rel="stylesheet" media="screen" type="text/css" href="'.DOKU_BASE.'lib/exe/css.php" />';
}

function dg_add_js(){
    echo '<script type="text/javascript" src="'.DOKU_BASE.'lib/exe/js.php" />';
}

/* Add our filter */
add_filter('the_content', 'dg_parse_entry', 1);

/* Add action */
add_action('wp_head', 'dg_add_css', 1);
add_action('wp_head', 'dg_add_js', 1);
?>
